<?php
/**********************************************************************************
* Subs-BoardNews.php                                                              *
***********************************************************************************
* for use with SMF: Simple Machines Forum                                         *
* =============================================================================== *
* Software Version:           BoardNews 1.1                                       *
* Software by:                Oskari Rauta/Jake Irons (http://www.roadrunner.cx)  *
* Copyright 2007 by:          RoadRunner.cx (http://www.roadrunner.cx)            *
* Updates at:                 http://www.simplemachines.org                       *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it.        *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* The latest version can always be found at http://www.simplemachines.org.        *
**********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

/*	This file contains function(s) needed by BoardNews MOD.

	function genboardnews()
		- is called to fill $context['random_news_line'];
*/

function get_boardNews($board = null, $limit = null, $start = null, $length = null, $output_method = 'echo')
{
	global $scripturl, $db_prefix, $txt, $settings, $modSettings, $context;
	global $func;

	loadLanguage('Stats');

	// Must be integers....
	if ($limit === null)
		$limit = isset($_GET['limit']) ? (int) $_GET['limit'] : 5;
	else
		$limit = (int) $limit;

	if ($start === null)
		$start = isset($_GET['start']) ? (int) $_GET['start'] : 0;
	else
		$start = (int) $start;

	// Was a board passed?
	if ($board !== null)
	{
		// Are we using an array?
		if (is_array($board))
		{
			// Make sure all values are numeric.
			foreach ($board as $key => $board_id)
				$board[$key] = (int) $board_id;
		}
		// Otherwise, it's probably a number.
		else
		{
			$board = (int) $board;
		}
	}
	// No board? Check GET variable.
	elseif (isset($_REQUEST['board']))
	{
		// Could it be an array?
		// You can pass a comma seperated list of boards, and they'll all be
		// used (eg. ?board=1,2,3,4,5).
		if (strpos($_REQUEST['board'], ',') !== false)
		{
			// Split up the string.
			$board = explode(',', $_REQUEST['board']);
			// Make sure all values are numeric.
			foreach ($board as $key => $board_id)
				$board[$key] = (int) $board_id;
		}
		// Probably a number (backwards-compatibility).
		else
		{
			$board = (int) $_REQUEST['board'];
		}
	}
	
	// WHERE clause in the queries.
	$boardQuery = 'ID_BOARD ' . (is_array($board) ? ('IN (' . implode(',', $board) . ')') : ('= ' . $board));

	if ($length === null)
		$length = isset($_GET['length']) ? (int) $_GET['length'] : 0;
	else
		$length = (int) $length;

	$limit = max(0, $limit);
	$start = max(0, $start);

	// If no boards were passed, get the first board guests can view
	// Otherwise, check if all the passed boards are valid.
	$request = db_query("
		SELECT ID_BOARD, name
		FROM {$db_prefix}boards
		WHERE " . ($board === null ? '' : $boardQuery . '
			AND ') . 'FIND_IN_SET(-1, memberGroups)
		ORDER BY ID_BOARD ASC' . ($board === null ? '
		LIMIT 1' : ''), __FILE__, __LINE__);
	
	// No boards? That's bad.
	if (mysql_num_rows($request) == 0)
	{
		if ($output_method == 'echo')
			die($txt['smf_news_error2']);
		else
			return array();
	}

	$boardInfo = array();
	// Empty the board ID array - We're grabbing the IDs from scratch.
	unset($board);
	$board = array();
	
	// Loop through all returned boards.
	while ($row = mysql_fetch_assoc($request))
	{
		// Add this board to the arrays.
		// Board info - Used later on (in the stuff returned)
		$boardInfo[$row['ID_BOARD']] = $row;
		$board[] = $row['ID_BOARD'];
	}
	mysql_free_result($request);
	
	// Let's get the new WHERE clause
	// Note: The $board array does not need to be sanitised, its data has been
	// returned from the database (and is safe).
	$boardQuery = 'ID_BOARD IN (' . implode(',', $board) . ')';

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find the post ids.
	$request = db_query("
		SELECT ID_FIRST_MSG
		FROM {$db_prefix}topics
		WHERE $boardQuery
		ORDER BY ID_FIRST_MSG DESC
		LIMIT $start, $limit", __FILE__, __LINE__);
	$posts = array();
	while ($row = mysql_fetch_assoc($request))
		$posts[] = $row['ID_FIRST_MSG'];
	mysql_free_result($request);

	if (empty($posts))
		return array();

	// Find the posts.
	$request = db_query("
		SELECT
			m.icon, m.subject, m.body, IFNULL(mem.realName, m.posterName) AS posterName, m.posterTime,
			t.numReplies, t.ID_TOPIC, m.ID_MEMBER, m.smileysEnabled, m.ID_MSG, t.locked, t.ID_BOARD
		FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
		WHERE t.ID_FIRST_MSG IN (" . implode(', ', $posts) . ")
			AND m.ID_MSG = t.ID_FIRST_MSG
		ORDER BY t.ID_FIRST_MSG DESC
		LIMIT " . count($posts), __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// If we want to limit the length of the post.
		if (!empty($length) && $func['strlen']($row['body']) > $length)
		{
			$row['body'] = $func['substr']($row['body'], 0, $length);

			// The first space or line break. (<br />, etc.)
			$cutoff = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));

			if ($cutoff !== false)
				$row['body'] = $func['substr']($row['body'], 0, $cutoff);
			$row['body'] .= '...';
		}

		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']);

		// Check that this message icon is there...
		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		censorText($row['subject']);
		censorText($row['body']);
		
		$return[] = array(
			'id' => $row['ID_TOPIC'],
			'message_id' => $row['ID_MSG'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			'subject' => strip_tags(preg_replace('#\[(.+?)\]#ie', '', $row['subject'])),
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'body' => strip_tags(preg_replace('#\[(.+?)\]#ie', '', str_replace('<br />',' ',$row['body']))),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['numReplies'] . ' ' . ($row['numReplies'] == 1 ? $txt['smf_news_1'] : $txt['smf_news_2']) . '</a>',
			'replies' => $row['numReplies'],
			'comment_href' => !empty($row['locked']) ? '' : $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'],
			'comment_link' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'new_comment' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => !empty($row['ID_MEMBER']) ? $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] : '',
				'link' => !empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>' : $row['posterName']
			),
			'locked' => !empty($row['locked']),
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $boardInfo[$row['ID_BOARD']]['name'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'],
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '">' . $boardInfo[$row['ID_BOARD']]['name'] . '</a>'
			),
			'is_last' => false
		);
	}
	mysql_free_result($request);

	if (empty($return))
		return $return;

	$return[count($return) - 1]['is_last'] = true;

	if ($output_method != 'echo')
		return $return;

	foreach ($return as $news)
	{
		echo '
			<div>
				<a href="', $news['href'], '">', $news['icon'], '</a> <b>', $news['subject'], '</b>
				<div class="smaller">', $news['time'], ' ', $txt[525], ' ', $news['poster']['link'], '</div>

				<div class="post" style="padding: 2ex 0;">', $news['body'], '</div>

				', $news['link'], $news['locked'] ? '' : ' | ' . $news['comment_link'], '
			</div>';

		if (!$news['is_last'])
			echo '
			<hr style="margin: 2ex 0;" width="100%" />';
	}
}

function genboardnews()
{
global $context, $boards, $boardList, $cat_tree, $modSettings, $db_prefix, $sourcedir, $user_info, $txt;

if (!$modSettings['bnews_enabled'])
	return;

require_once($sourcedir . '/Subs-Boards.php');
//require_once($sourcedir . '/SSI.php');

$context['bnews'] = array();
$amountBoards = 0;
$newsBoards = array();
$newsID = 0;

getBoardTree();

foreach ($cat_tree as $catid => $tree)
	foreach ($boardList[$catid] as $boardid)
		{
			++$amountBoards;
			if (isset($modSettings['bnews_id' . $amountBoards]))
				if ($modSettings['bnews_id' . $amountBoards])
					$newsBoards[] = $boardid;
		}

$newsItems = get_boardNews($newsBoards, $modSettings['bnews_max'], null, null, 'noecho');

if (count($newsItems) == 0)
	return;

loadLanguage('index');

if (isset($context['random_news_line']))
    if ($context['random_news_line'] != '')
	$context['random_news_line'] .= '</span><br/>
<span class="smalltext" style="visibility: hidden;"><b>' . $txt[102] . '</b>: ';

foreach ($newsItems as $newsItem)
{
	$context['random_news_line'] .= (($newsID==0) ? '' : ('<span class="smalltext" style="visibility: hidden;"><b>' . $txt[102] . '</b>: ')) . '
	</span><span class="smalltext"><a href="' . $newsItem['href'] . '" style="text-decoration:none;" title="' . (strlen($newsItem['body']) > $modSettings['bnews_hover'] ? ((substr($newsItem['body'], 0, $modSettings['bnews_hover'] - 2)) . '..') : $newsItem['body']) . '" alt="' . (strlen($newsItem['body']) > $modSettings['bnews_hover'] ? ((substr($newsItem['body'], 0, $modSettings['bnews_hover'] - 2)) . '..') : $newsItem['body']) . '">
' . (strlen($newsItem['subject']) > $modSettings['bnews_chars'] ? ((doUBBC(substr($newsItem['subject'], 0, $modSettings['bnews_chars'] - 2),true)) . '..') : doUBBC($newsItem['subject'],true)) . '</a><br/></span>';
    $newsID++;
}
$context['random_news_line'] = substr($context['random_news_line'], 0, -7);
}

?>